{+doc
+NOMBRE:params
+CREACION: 27/7/93
+AUTORES:rch
+REGISTRO:
+TIPO: Unidad Pascal.
+PROPOSITO: facilidad para lectura de parmetros en la lnea de comandos
+PROYECTO: rchlib
                                                              
+REVISION:
+AUTOR:
+DESCRIPCION:
-doc}
{$IFNDEF WINDOWS}
{$O+}
{$ENDIF}
unit Params;

interface

uses
  xMatDefs, horrores, lexemas;

const
  ModoIgnorarMayusculasMinusculas: boolean = True;

function ParamInteger(npar: word): integer;
function ParamLongInt(npar: word): longint;
function ParamNReal(npar: word): NReal;

function IndiceParamModif(s: string): integer;

function ModifStr(s: string; var param: string): boolean;
function ModifInteger(s: string; var param: integer): boolean;
function ModifLongInt(s: string; var param: longint): boolean;
function ModifNReal(s: string; var param: NReal): boolean;

implementation

function IndiceParamModif(s: string): integer;
var
  k: integer;
  ModificadorPresente: boolean;
  ts: string;
begin
  if ModoIgnorarMayusculasMinusculas then
    s := UpStr(s);
  ModificadorPresente := False;
  k := 1;
  while (k <= ParamCount) and (not ModificadorPresente) do
  begin
    ts := ParamStr(k);
    if ModoIgnorarMayusculasMinusculas then
      ts := UpStr(ts);
    if pos(s, ts) <> 0 then
      ModificadorPresente := True
    else
      Inc(k);
  end;
  if ModificadorPresente then
    IndiceParamModif := k
  else
    IndiceParamModif := -1;
end;

function ModifStr(s: string; var param: string): boolean;
var
  k, j: integer;
  ts: string;
  ModificadorPresente: boolean;
  letra: char;
begin
  k := IndiceParamModif(s);
  if k < 0 then
  begin
    ModifStr := False;
  end
  else
  begin
    if ModoIgnorarMayusculasMinusculas then
      s := UpStr(s);
    ts := ParamStr(k);
    if ModoIgnorarMayusculasMinusculas then
      ts := UpStr(ts);
    k := pos(s, ts) + length(s);
    if k = 0 then
      error(' ModifStr: incoherencia ');
    param := '';
    if k <= length(ts) then
      letra := ts[k]
    else
      letra := '/';
    while (k <= length(ts)) and (not (letra in ({Cualificadores+}Operadores))) do
    begin
      param := param + letra;
      Inc(k);
      if k <= length(ts) then
        letra := ts[k]
      else
        letra := '/';
    end;
    ModifStr := True;
  end;
end;



function ModifInteger(s: string; var param: integer): boolean;
var
  ts: string;
  r: integer;
  res: integer;
begin
  if ModifStr(s, ts) then
  begin
    val(ts, r, res);
    if res <> 0 then
      error('ParamInteger, par: ' + s);
    param := r;
    ModifInteger := True;
  end
  else
    ModifInteger := False;
end;

function ModifNReal(s: string; var param: NReal): boolean;
var
  ts: string;
  r: NReal;
  res: integer;
begin
  if ModifStr(s, ts) then
  begin
    val(ts, r, res);
    if res <> 0 then
      error('ModifNReal, par: ' + ts);
    param := r;
    ModifNReal := True;
  end
  else
    ModifNReal := False;
end;




function ModifLongInt(s: string; var param: longint): boolean;
var
  ts: string;
  r: longint;
  res: integer;
begin
  if ModifStr(s, ts) then
  begin
    val(ts, r, res);
    if res <> 0 then
      error('ParamInteger, par: ' + s);
    param := r;
    ModifLongInt := True;
  end
  else
    ModifLongInt := False;
end;



function ParamInteger(npar: word): integer;
var
  s: string;
  r: integer;
  res: integer;
begin
  s := ParamStr(npar);
  val(s, r, res);
  if res <> 0 then
    error('ParamInteger, par: ' + s);
  ParamInteger := r;
end;

function ParamLongInt(npar: word): longint;
var
  s: string;
  r: longint;
  res: integer;
begin
  s := ParamStr(npar);
  val(s, r, res);
  if res <> 0 then
    error('ParamLongInt, par: ' + s);
  ParamLongInt := r;
end;

function ParamNReal(npar: word): NReal;
var
  s: string;
  r: NReal;
  res: integer;
begin
  s := ParamStr(npar);
  val(s, r, res);
  if res <> 0 then
    error('ParamNReal, par: ' + s);
  ParamNReal := r;
end;



end.
