unit ufuncionesbasicas;

interface

uses
  Classes, SysUtils, uparseadorsupersimple;

procedure AgregarFunciones(Evaluador: TEvaluadorExpresionesSimples);

type
  TFun_F_FF_OfObject = function(x, y: double): double of object;
  TFun_F_F_OfObject = function(x: double): double of object;

  { TFunc_F_FF_OfObject }
  TFunc_F_FF_OfObject = class(TOperProcDef)
    func_ptr: TFun_F_FF_OfObject;
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create(nombre_: string; func_ptr_: TFun_F_FF_OfObject);
  end;

  { TFunc_F_F_OfObject }
  TFunc_F_F_OfObject = class(TOperProcDef)
    func_ptr: TFun_F_F_OfObject;
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create(nombre_: string; func_ptr_: TFun_F_F_OfObject);
  end;


  {
Funciones definidas.
Nombre_TipoResultado_TiposEntradas
  abs_F_F
  ceil_I_F
  cos_F_F
  exp_F_F
  floor_I_F
  inv_F_F
  ln_F_F
  max_F_FF
  min_F_FF
  neg_F_F
  neg_I_I
  pow_F_FF
  round_I_F
  rsqrt_F_F   y = 1/sqrt( x )
  sign_I_F
  sign_I_I
  sin_F_F
  sqrt_F_F
  sqr_F_F
  sqr_I_I
  }


implementation

uses
  Math;

type
  { TFuncSqrt_F_F }
  TFuncSqrt_F_F = class(TOperProcDef)
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create;
  end;

  { TFuncSqr_F_F }
  TFuncSqr_F_F = class(TOperProcDef)
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create;
  end;

  { TFuncSqr_I_I }
  TFuncSqr_I_I = class(TOperProcDef)
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create;
  end;

  { TFuncSign_I_I }
  TFuncSign_I_I = class(TOperProcDef)
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create;
  end;

  { TFuncSign_I_F }
  TFuncSign_I_F = class(TOperProcDef)
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create;
  end;

  { TFuncRSqrt_F_F } // y = 1/sqrt( x )
  TFuncRSqrt_F_F = class(TOperProcDef)
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create;
  end;

  { TFuncRound_I_F }
  TFuncRound_I_F = class(TOperProcDef)
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create;
  end;

  { TFuncNeg_I_I }
  TFuncNeg_I_I = class(TOperProcDef)
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create;
  end;

  { TFuncNeg_F_F }
  TFuncNeg_F_F = class(TOperProcDef)
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create;
  end;


  { TFuncMin_F_FF }
  TFuncMin_F_FF = class(TOperProcDef)
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create;
  end;

  { TFuncMax_F_FF }
  TFuncMax_F_FF = class(TOperProcDef)
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create;
  end;


  { TFuncLn_F_F }
  TFuncLn_F_F = class(TOperProcDef)
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create;
  end;

  { TFuncInv_F_F }
  TFuncInv_F_F = class(TOperProcDef)
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create;
  end;


  { TFuncFloor_I_F }
  TFuncFloor_I_F = class(TOperProcDef)
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create;
  end;

  { TFuncCeil_I_F }
  TFuncCeil_I_F = class(TOperProcDef)
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create;
  end;

  { TFuncAbs_F_F }
  TFuncAbs_F_F = class(TOperProcDef)
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create;
  end;


  { TFuncSin_F_F }
  TFuncSin_F_F = class(TOperProcDef)
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create;
  end;

  { TFuncCos_F_F }
  TFuncCos_F_F = class(TOperProcDef)
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create;
  end;

  { TFuncExp_F_F }
  TFuncExp_F_F = class(TOperProcDef)
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create;
  end;

  { TFuncPow_F_FF }
  TFuncPow_F_FF = class(TOperProcDef)
    procedure evaluar(salida: TExpresion; entradas: TExprLst); override;
    constructor Create;
  end;

procedure TFuncSqr_I_I.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  res.val.val_I := sqr( parA.ValAsInt );
end;

constructor TFuncSqr_I_I.Create;
begin
  inherited Create('sqr', 'I', 'I');
end;

procedure TFuncSqr_F_F.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  res.val.val_F := sqr( parA.ValAsFloat );
end;

constructor TFuncSqr_F_F.Create;
begin
  inherited Create('sqr', 'F', 'F');
end;

procedure TFuncSqrt_F_F.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  res.val.val_F := sqrt( parA.ValAsFloat );
end;

constructor TFuncSqrt_F_F.Create;
begin
  inherited Create('sqrt', 'F', 'F');
end;

procedure TFuncSign_I_I.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  res.val.val_I := sign( parA.ValAsInt );
end;

constructor TFuncSign_I_I.Create;
begin
  inherited Create('sign', 'I', 'I');
end;

procedure TFuncSign_I_F.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  res.val.val_I := sign( parA.ValAsFloat );
end;

constructor TFuncSign_I_F.Create;
begin
  inherited Create('sign', 'I', 'F');
end;

procedure TFuncNeg_I_I.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  res.val.val_I := -parA.ValAsInt;
end;

constructor TFuncNeg_I_I.Create;
begin
  inherited Create('neg', 'I', 'I');
end;

procedure TFuncRSqrt_F_F.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  res.val.val_F := 1/ sqrt( parA.ValAsFloat );
end;

constructor TFuncRSqrt_F_F.Create;
begin
  inherited Create('rsqrt', 'F', 'F');
end;


procedure TFuncRound_I_F.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  res.val.val_I := -parA.ValAsInt;
end;

constructor TFuncRound_I_F.Create;
begin
  inherited Create('round', 'I', 'F');
end;

procedure TFuncNeg_F_F.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  res.val.val_F := -parA.ValAsFloat;
end;

constructor TFuncNeg_F_F.Create;
begin
  inherited Create('neg', 'F', 'F');
end;


procedure TFuncMin_F_FF.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA, parB: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  parB := entradas[1];
  res.val.val_F := min(parA.ValAsFloat, parB.ValAsFloat);
end;

constructor TFuncMin_F_FF.Create;
begin
  inherited Create('min', 'F', 'FF');
end;

procedure TFuncMax_F_FF.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA, parB: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  parB := entradas[1];
  res.val.val_F := max(parA.ValAsFloat, parB.ValAsFloat);
end;


constructor TFuncMax_F_FF.Create;
begin
  inherited Create('max', 'F', 'FF');
end;



procedure TFuncLn_F_F.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  res.val.val_F := 1 / parA.ValAsFloat;
end;

constructor TFuncLn_F_F.Create;
begin
  inherited Create('ln', 'F', 'F');
end;

procedure TFuncInv_F_F.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  res.val.val_F := 1 / parA.ValAsFloat;
end;

constructor TFuncInv_F_F.Create;
begin
  inherited Create('inv', 'F', 'F');
end;

procedure TFuncFloor_I_F.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  res.val.val_I := floor(parA.ValAsFloat);
end;

constructor TFuncFloor_I_F.Create;
begin
  inherited Create('floor', 'I', 'F');
end;

procedure TFuncCeil_I_F.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  res.val.val_I := ceil(parA.ValAsFloat);
end;

constructor TFuncCeil_I_F.Create;
begin
  inherited Create('ceil', 'I', 'F');
end;

procedure TFuncAbs_F_F.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  res.val.val_F := abs(parA.ValAsFloat);
end;



constructor TFuncAbs_F_F.Create;
begin
  inherited Create('abs', 'F', 'F');
end;


{ TFunc_F_F_OfObject }
procedure TFunc_F_F_OfObject.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  res.val.val_F := func_ptr(parA.ValAsFloat);
end;

constructor TFunc_F_F_OfObject.Create(nombre_: string; func_ptr_: TFun_F_F_OfObject);
begin
  inherited Create(nombre_, 'F', 'F');
  func_ptr := func_ptr_;
end;

{ TFunc_F_FF_OfObject }
procedure TFunc_F_FF_OfObject.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA, parB: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  parB := entradas[1];
  res.val.val_F := func_ptr(parA.ValAsFloat, parB.ValAsFloat);
end;

constructor TFunc_F_FF_OfObject.Create(nombre_: string; func_ptr_: TFun_F_FF_OfObject);
begin
  inherited Create(nombre_, 'F', 'FF');
  func_ptr := func_ptr_;
end;


// sin
procedure TFuncSin_F_F.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  res.val.val_F := sin(parA.ValAsFloat);
end;

constructor TFuncSin_F_F.Create;
begin
  inherited Create('sin', 'F', 'F');
end;

// cos
procedure TFuncCos_F_F.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  res.val.val_F := cos(parA.ValAsFloat);
end;

constructor TFuncCos_F_F.Create;
begin
  inherited Create('cos', 'F', 'F');
end;

// exp
procedure TFuncExp_F_F.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  res.val.val_F := exp(parA.ValAsFloat);
end;

constructor TFuncExp_F_F.Create;
begin
  inherited Create('exp', 'F', 'F');
end;



// pow
procedure TFuncPow_F_FF.evaluar(salida: TExpresion; entradas: TExprLst);
var
  res, parA, parB: TExpresion;
begin
  res := salida;
  parA := entradas[0];
  parB := entradas[1];
  res.val.val_F := power(parA.ValAsFloat, parB.ValAsFloat);
end;

constructor TFuncPow_F_FF.Create;
begin
  inherited Create('pow', 'F', 'FF');
end;


procedure AgregarFunciones(Evaluador: TEvaluadorExpresionesSimples);
begin
  Evaluador.CatalogoFuncionesEstandar.add( TFuncAbs_F_F.Create );
  Evaluador.CatalogoFuncionesEstandar.add( TFuncCeil_I_F.Create );
  Evaluador.CatalogoFuncionesEstandar.add( TFuncCos_F_F.Create );
  Evaluador.CatalogoFuncionesEstandar.add( TFuncExp_F_F.Create );
  Evaluador.CatalogoFuncionesEstandar.add( TFuncFloor_I_F.Create );
  Evaluador.CatalogoFuncionesEstandar.add( TFuncInv_F_F.Create );
  Evaluador.CatalogoFuncionesEstandar.add( TFuncLn_F_F.Create );
  Evaluador.CatalogoFuncionesEstandar.add( TFuncMax_F_FF.Create );
  Evaluador.CatalogoFuncionesEstandar.add( TFuncMin_F_FF.Create );
  Evaluador.CatalogoFuncionesEstandar.add( TFuncNeg_F_F.Create );
  Evaluador.CatalogoFuncionesEstandar.add( TFuncNeg_I_I.Create );
  Evaluador.CatalogoFuncionesEstandar.add( TFuncPow_F_FF.Create );
  Evaluador.CatalogoFuncionesEstandar.add( TFuncRound_I_F.Create );
  Evaluador.CatalogoFuncionesEstandar.add( TFuncRSqrt_F_F.Create );
  Evaluador.CatalogoFuncionesEstandar.add( TFuncSign_I_F.Create );
  Evaluador.CatalogoFuncionesEstandar.add( TFuncSign_I_I.Create );
  Evaluador.CatalogoFuncionesEstandar.add( TFuncSin_F_F.Create );
  Evaluador.CatalogoFuncionesEstandar.add( TFuncSqr_F_F.Create );
  Evaluador.CatalogoFuncionesEstandar.add( TFuncSqr_I_I.Create );
end;

end.

